﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlanetGravityCollider : MonoBehaviour
{
    public float gravity;

    private void OnTriggerEnter2D(Collider2D collision)
    {
        collision.GetComponent<PlayerControllerScript>().PlanetBonus += 100;
    }

    private void OnTriggerExit2D(Collider2D collision)
    {
        collision.GetComponent<PlayerControllerScript>().PlanetBonus -= 100;
    }

    void OnTriggerStay2D(Collider2D collider)
    {
        ApplyGravity(collider.gameObject);
    }

    void ApplyGravity(GameObject playerShip)
    {
        var heading = transform.position - playerShip.transform.position;
        var distance = heading.magnitude;
        var direction = heading / distance;
        playerShip.GetComponent<Rigidbody2D>().AddForce(direction * gravity * Time.deltaTime);
    }
}
