﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlanetSpawnScript : MonoBehaviour {

    public float OuterGravityMutiplier;
    public float InnerGravityMultiplier;
    public float NumberOfPlanets;
    public float PlanetScaleMin;
    public float PlanetScaleMax;
    public float MapSize;

    public GameObject PlanetPrefab;

    private int randSeed;

    private List<Vector3> planetSpawns;

    // Use this for initialization
    void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    private void Awake()
    {
        randSeed = Random.Range(0, 1000);
        planetSpawns = new List<Vector3>();
        SpawnPlanets();
    }

    public void SpawnPlanets()
    {
        Random.InitState(randSeed);

        GameObject playerObject = GameObject.Find("PlayerObject");

        float mapSizeAdjusted = MapSize;
        float scaleMinAdjusted = PlanetScaleMin;
        float scaleMaxAdjusted = PlanetScaleMax;
        float scaleAdjusted;

        float playerX = playerObject.transform.position.x;
        float playerY = playerObject.transform.position.y;

        float drawMinX = playerX - (mapSizeAdjusted / 2);
        float drawMaxX = playerX + (mapSizeAdjusted / 2);
        float drawMinY = playerY - (mapSizeAdjusted / 2);
        float drawMaxY = playerY + (mapSizeAdjusted / 2);

        float safeAdjust = 100;

        for (int i = 0; i < NumberOfPlanets; i++)
        {
            scaleAdjusted = Random.Range(scaleMinAdjusted, scaleMaxAdjusted);
            GameObject newPlanet = Instantiate<GameObject>(PlanetPrefab);
            Vector3 newPlanetLocation = new Vector3(Random.Range(drawMinX, drawMaxX), Random.Range(drawMinY, drawMaxY), 1);
            Vector3 newPlanetSafeLocation = new Vector3(Mathf.Ceil(newPlanetLocation.x / safeAdjust), Mathf.Ceil(newPlanetLocation.y / safeAdjust), 1);

            while (planetSpawns.Contains(newPlanetLocation))
            {
                newPlanetLocation = new Vector3(Random.Range(drawMinX, drawMaxX), Random.Range(drawMinY, drawMaxY), 1);
                newPlanetSafeLocation = new Vector3(Mathf.Ceil(newPlanetLocation.x / safeAdjust), Mathf.Ceil(newPlanetLocation.y / safeAdjust), 1);
            }

            newPlanet.transform.position = newPlanetLocation;

            planetSpawns.Add(newPlanetSafeLocation);

            newPlanet.transform.localScale = new Vector3(scaleAdjusted, scaleAdjusted, 1);
        }
    }
}
